scala.tools.nsc.backend.icode.analysis.CopyPropagation

# CopyAnalysis

###
Related Doc: package CopyPropagation

#### final class CopyAnalysis extends DataFlowAnalysis[copyLattice.type]

Source
  CopyPropagation.scala

Linear Supertypes
DataFlowAnalysis[copyLattice.type], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. CopyAnalysis
2. DataFlowAnalysis
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new CopyAnalysis()

### Type Members

1. #### type P = Global.icodes.BasicBlock

   A type for program points.

   A type for program points.

   Definition Classes
     CopyAnalysis → DataFlowAnalysis

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from CopyAnalysis to any2stringadd[CopyAnalysis] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (CopyAnalysis, B)

   Implicit information
     This member is added by an implicit conversion from CopyAnalysis to ArrowAssoc[CopyAnalysis] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def backwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

   Definition Classes
     DataFlowAnalysis

8. #### def blockTransfer(b: Global.icodes.BasicBlock, in: Elem): Elem

9. #### final def cleanReferencesTo(s: State, target: Location): Unit

   Remove all references to this local variable from both stack and bindings.

   Remove all references to this local variable from both stack and bindings. It is called when a new assignment destroys previous copy-relations.

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### def ensuring(cond: (CopyAnalysis) ⇒ Boolean, msg: ⇒ Any): CopyAnalysis

    Implicit information
      This member is added by an implicit conversion from CopyAnalysis to Ensuring[CopyAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (CopyAnalysis) ⇒ Boolean): CopyAnalysis

    Implicit information
      This member is added by an implicit conversion from CopyAnalysis to Ensuring[CopyAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): CopyAnalysis

    Implicit information
      This member is added by an implicit conversion from CopyAnalysis to Ensuring[CopyAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): CopyAnalysis

    Implicit information
      This member is added by an implicit conversion from CopyAnalysis to Ensuring[CopyAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from CopyAnalysis to StringFormat[CopyAnalysis] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### def forwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    f

      the transfer function.

    Definition Classes
      DataFlowAnalysis

20. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

22. #### val in: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

23. #### def init(m: Global.icodes.IMethod): Unit

24. #### def init(f: ⇒ Unit): Unit

    Definition Classes
      DataFlowAnalysis

25. #### def interpret(in: Elem, i: Global.icodes.Instruction): Elem

    Abstract interpretation for one instruction.

26. #### final def invalidateRecords(state: State): Unit

    Drop everything known about mutable record fields.

    Drop everything known about mutable record fields.

    A simple escape analysis would help here. Some of the records we track never leak to other methods, therefore they can not be changed. We should not drop their bindings in this case. A closure object would be such an example. Some complications:

    - outer pointers. An closure escapes as an outer pointer to another nested closure.

27. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

28. #### final def isPureMethod(m: Global.Symbol): Boolean

    Is symbol `m` a pure method?

29. #### var iterations: Int

    the number of times we iterated before reaching a fixpoint.

    the number of times we iterated before reaching a fixpoint.

    Definition Classes
      DataFlowAnalysis

30. #### val lattice: copyLattice.type

    Definition Classes
      CopyAnalysis → DataFlowAnalysis

31. #### var method: Global.icodes.IMethod

32. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

33. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

35. #### val out: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

36. #### def run(): Unit

    Definition Classes
      CopyAnalysis → DataFlowAnalysis

37. #### final def simulateCall(state: State, method: Global.Symbol, static: Boolean): State

    Update the state `s` after the call to `method`.

    Update the state `s` after the call to `method`. The stack elements are dropped and replaced by the result of the call. If the method is impure, all bindings to record fields are cleared.

38. #### var stat: Boolean

    collect statistics?

    collect statistics?

    Definition Classes
      DataFlowAnalysis

39. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

40. #### final def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      CopyAnalysis → AnyRef → Any

41. #### val visited: HashSet[P]

    Definition Classes
      DataFlowAnalysis

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### val worklist: Set[P]

    Definition Classes
      DataFlowAnalysis

46. #### def →[B](y: B): (CopyAnalysis, B)

    Implicit information
      This member is added by an implicit conversion from CopyAnalysis to ArrowAssoc[CopyAnalysis] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from DataFlowAnalysis[copyLattice.type]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from CopyAnalysis to any2stringadd[CopyAnalysis]

### Inherited by implicit conversion StringFormat from CopyAnalysis to StringFormat[CopyAnalysis]

### Inherited by implicit conversion Ensuring from CopyAnalysis to Ensuring[CopyAnalysis]

### Inherited by implicit conversion ArrowAssoc from CopyAnalysis to ArrowAssoc[CopyAnalysis]

### Ungrouped